Index: /trunk/include/cf_base.h
===================================================================
--- /trunk/include/cf_base.h	(revision 9)
+++ /trunk/include/cf_base.h	(revision 10)
@@ -13,4 +13,6 @@
 #define CF_ERROR						-1
 
+#define NAME_LENGTH						128
+
 #define CF_ERROR_BASE					CF_ERROR * 1000
 
@@ -20,4 +22,5 @@
 #define CF_ERROR_MUTEX					CF_ERROR_BASE * 5
 #define CF_ERROR_DEBUG					CF_ERROR_BASE * 6
+#define CF_ERROR_LOG					CF_ERROR_BASE * 7
 
 #ifdef _WIN32
Index: /trunk/include/cf_debug.h
===================================================================
--- /trunk/include/cf_debug.h	(revision 9)
+++ /trunk/include/cf_debug.h	(revision 10)
@@ -31,6 +31,4 @@
 # define CF_DEBUG_CALLSTACK_POP()
 #endif // #ifdef _DEBUG
-
-#define NAME_LENGTH	128
 
 typedef void *	CF_Debug_Ctx;
@@ -74,3 +72,7 @@
 						 CF_Debug_CallStack	* callstack);
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif // #ifndef __CF_DEBUG_H__
Index: /trunk/src/cf_debug.c
===================================================================
--- /trunk/src/cf_debug.c	(revision 9)
+++ /trunk/src/cf_debug.c	(revision 10)
@@ -22,4 +22,5 @@
 	if (__ctx == NULL)						\
 		return CF_ERROR_DEBUG_INVALID_CTX
+
 #define GET_CTX_OSTREAM(__ctx)				\
 	((((CF_DEBUG_CTX *)__ctx)->fp == NULL)	\
@@ -37,5 +38,5 @@
 
 /* implementation of CF_Debug_Ctx */
-typedef struct __cf_debug_context__
+typedef struct __cf_debug_ctx__
 {
 	char	file[NAME_LENGTH + 1];
Index: /trunk/src/makefile
===================================================================
--- /trunk/src/makefile	(revision 9)
+++ /trunk/src/makefile	(revision 10)
@@ -41,6 +41,7 @@
 					cf_thread		\
 					cf_debug		\
+					cf_log			\
 
-LIB_NAME		= CF
+LIB_NAME		= cf
 
 CC				= gcc
@@ -89,8 +90,2 @@
 dummy:
 
-# test
-test: all
-	$(CXX) $(CXXFLAGS) $(INCLUDES) $(CXXDEFS) -o $(OBJ_PATH)/main.o -c main.cpp
-	$(LD) $(LDFLAGS) -o $(TARGET_PATH)/cf.ex $(OBJ_PATH)/main.o -L$(TARGET_PATH) -lpthread
-	LD_LIBRARY_PATH=$(TARGET_PATH) $(TARGET_PATH)/cf.ex
-
Index: unk/windows/libCF.sln
===================================================================
--- /trunk/windows/libCF.sln	(revision 9)
+++ 	(revision )
@@ -1,20 +1,0 @@
-﻿
-Microsoft Visual Studio Solution File, Format Version 10.00
-# Visual Studio 2008
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libCF", "libCF/libCF.vcproj", "{E5FB2D95-3841-464C-B23F-94ADA4499FE6}"
-EndProject
-Global
-	GlobalSection(SolutionConfigurationPlatforms) = preSolution
-		Debug|Win32 = Debug|Win32
-		Release|Win32 = Release|Win32
-	EndGlobalSection
-	GlobalSection(ProjectConfigurationPlatforms) = postSolution
-		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Debug|Win32.ActiveCfg = Debug|Win32
-		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Debug|Win32.Build.0 = Debug|Win32
-		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Release|Win32.ActiveCfg = Release|Win32
-		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Release|Win32.Build.0 = Release|Win32
-	EndGlobalSection
-	GlobalSection(SolutionProperties) = preSolution
-		HideSolutionNode = FALSE
-	EndGlobalSection
-EndGlobal
Index: /trunk/windows/libcf.ln
===================================================================
--- /trunk/windows/libcf.ln	(revision 10)
+++ /trunk/windows/libcf.ln	(revision 10)
@@ -0,0 +1,20 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 10.00
+# Visual Studio 2008
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libcf", "libcf/libcf.vcproj", "{E5FB2D95-3841-464C-B23F-94ADA4499FE6}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Win32 = Debug|Win32
+		Release|Win32 = Release|Win32
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Debug|Win32.ActiveCfg = Debug|Win32
+		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Debug|Win32.Build.0 = Debug|Win32
+		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Release|Win32.ActiveCfg = Release|Win32
+		{E5FB2D95-3841-464C-B23F-94ADA4499FE6}.Release|Win32.Build.0 = Release|Win32
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: /trunk/windows/libcf/libcf.vcproj
===================================================================
--- /trunk/windows/libcf/libcf.vcproj	(revision 10)
+++ /trunk/windows/libcf/libcf.vcproj	(revision 10)
@@ -0,0 +1,237 @@
+<?xml version="1.0" encoding="ks_c_5601-1987"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="9.00"
+	Name="libCF"
+	ProjectGUID="{E5FB2D95-3841-464C-B23F-94ADA4499FE6}"
+	RootNamespace="libCF"
+	Keyword="Win32Proj"
+	TargetFrameworkVersion="196613"
+	>
+	<Platforms>
+		<Platform
+			Name="Win32"
+		/>
+	</Platforms>
+	<ToolFiles>
+	</ToolFiles>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
+			IntermediateDirectory="$(ConfigurationName)"
+			ConfigurationType="2"
+			CharacterSet="1"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="..\..\include"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;LIBCF_EXPORTS"
+				MinimalRebuild="true"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				DebugInformationFormat="4"
+				DisableSpecificWarnings="4996"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLinkerTool"
+				LinkIncremental="2"
+				GenerateDebugInformation="true"
+				SubSystem="2"
+				TargetMachine="1"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
+			IntermediateDirectory="$(ConfigurationName)"
+			ConfigurationType="2"
+			CharacterSet="1"
+			WholeProgramOptimization="1"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="2"
+				EnableIntrinsicFunctions="true"
+				AdditionalIncludeDirectories="..\..\include"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;LIBCF_EXPORTS"
+				RuntimeLibrary="2"
+				EnableFunctionLevelLinking="true"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				DebugInformationFormat="3"
+				DisableSpecificWarnings="4996"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLinkerTool"
+				LinkIncremental="1"
+				GenerateDebugInformation="true"
+				SubSystem="2"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				TargetMachine="1"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="¼Ò½º ÆÄÀÏ"
+			Filter="cpp;c;cc;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
+			>
+			<File
+				RelativePath="..\..\src\cf_debug.c"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\cf_file.c"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\cf_local.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\cf_socket.c"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\cf_thread.c"
+				>
+			</File>
+		</Filter>
+		<Filter
+			Name="Çì´õ ÆÄÀÏ"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
+			>
+			<File
+				RelativePath="..\..\include\cf_base.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\include\cf_debug.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\include\cf_file.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\include\cf_socket.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\include\cf_thread.h"
+				>
+			</File>
+		</Filter>
+		<Filter
+			Name="¸®¼Ò½º ÆÄÀÏ"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx;tiff;tif;png;wav"
+			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}"
+			>
+			<File
+				RelativePath="..\..\src\makefile"
+				>
+			</File>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>