Index: /trunk/include/cf/bin.h
===================================================================
--- /trunk/include/cf/bin.h	(revision 14)
+++ /trunk/include/cf/bin.h	(revision 15)
@@ -63,10 +63,4 @@
 		 */
 		cf::size_t size() const;
-
-		/**
-		 * is empty
-		 * @return is empty ?
-		 */
-		cf::bool_t empty() const;
 
 		/**
Index: /trunk/include/cf/network.h
===================================================================
--- /trunk/include/cf/network.h	(revision 14)
+++ /trunk/include/cf/network.h	(revision 15)
@@ -50,10 +50,4 @@
 			 */
 			cf::uint16_t port() const;
-
-			/**
-			 * is empty ?
-			 * @return true; false
-			 */
-			cf::bool_t empty() const;
 		};
 
Index: /trunk/include/cf/task.h
===================================================================
--- /trunk/include/cf/task.h	(revision 14)
+++ /trunk/include/cf/task.h	(revision 15)
@@ -9,5 +9,5 @@
 #include "cf/exception.h"
 
-#define SYNCHRONIZED(_s)	for (cf::task::scopedLock _sl(&_s) ; _sl.locked() ; _sl.unlock())
+#define SYNCHRONIZED(_s)	for (cf::task::scopedLock _sl(&_s) ; _sl.isLocked() ; _sl.unlock())
 
 namespace cf
@@ -40,5 +40,5 @@
 			 * @return true; false
 			 */
-			virtual cf::bool_t locked() const = 0;
+			virtual cf::bool_t isLocked() const = 0;
 		};
 
@@ -90,5 +90,5 @@
 			 * @return true; false
 			 */
-			cf::bool_t locked() const;
+			cf::bool_t isLocked() const;
 		};
 
@@ -119,5 +119,5 @@
 			 * @return true; false
 			 */
-			cf::bool_t locked() const;
+			cf::bool_t isLocked() const;
 
 			/**
Index: /trunk/src/bin.cpp
===================================================================
--- /trunk/src/bin.cpp	(revision 14)
+++ /trunk/src/bin.cpp	(revision 15)
@@ -38,9 +38,4 @@
 {
 	return mBin.size();
-}
-
-cf::bool_t cf::bin::empty() const
-{
-	return mBin.empty();
 }
 
Index: /trunk/src/codec.cpp
===================================================================
--- /trunk/src/codec.cpp	(revision 14)
+++ /trunk/src/codec.cpp	(revision 15)
@@ -19,5 +19,5 @@
 	throw (cf::exception)
 {
-	if (in.empty())
+	if (in.size() == 0)
 		THROW_EXCEPTION("input is empty");
 
@@ -182,5 +182,5 @@
 	throw (cf::exception)
 {
-	if (in.empty())
+	if (in.size() == 0)
 		THROW_EXCEPTION("input is empty");
 
Index: /trunk/src/logger.cpp
===================================================================
--- /trunk/src/logger.cpp	(revision 14)
+++ /trunk/src/logger.cpp	(revision 15)
@@ -169,5 +169,5 @@
 		if (!mOpenMutex.trylock())
 		{
-			while (mOpenMutex.locked())
+			while (mOpenMutex.isLocked())
 				/* waiting */;
 
@@ -211,5 +211,5 @@
 		if (!mRenameMutex.trylock())
 		{
-			while (mRenameMutex.locked())
+			while (mRenameMutex.isLocked())
 				/* waiting */;
 
Index: /trunk/src/network.cpp
===================================================================
--- /trunk/src/network.cpp	(revision 14)
+++ /trunk/src/network.cpp	(revision 15)
@@ -153,9 +153,4 @@
 }
 
-cf::bool_t cf::network::host::empty() const
-{
-	return (address().empty() || port() == 0) ? true : false;
-}
-
 cf::network::tcp::tcp(const cf::socket_t attachedSocket)
 	throw (cf::exception)
@@ -351,6 +346,6 @@
 	throw (cf::exception)
 {
-	if (in.empty())
-		THROW_EXCEPTION("send data is null or zero-bytes");
+	if (in.size() == 0)
+		THROW_EXCEPTION("send data is zero-bytes");
 
 	cf::char_t * buf = reinterpret_cast<cf::char_t *>(in.buffer());
Index: /trunk/src/task.cpp
===================================================================
--- /trunk/src/task.cpp	(revision 14)
+++ /trunk/src/task.cpp	(revision 15)
@@ -136,5 +136,5 @@
 }
 
-cf::bool_t cf::task::mutex::locked() const
+cf::bool_t cf::task::mutex::isLocked() const
 {
 	return mIsLocked;
@@ -162,7 +162,7 @@
 }
 
-cf::bool_t cf::task::scopedLock::locked() const
-{
-	return mSynchronizer->locked();
+cf::bool_t cf::task::scopedLock::isLocked() const
+{
+	return mSynchronizer->isLocked();
 }
 
Index: /trunk/test/makefile
===================================================================
--- /trunk/test/makefile	(revision 14)
+++ /trunk/test/makefile	(revision 15)
@@ -22,5 +22,5 @@
 LIB_NAME		= cf++
 
-INCLUDES		= -I../include -I../src
+INCLUDES		= -I../include
 LIBRARIES		= -L$(BUILD_PATH) -l$(LIB_NAME) $(LIBS)
 LIBRARY_PATH	= .